<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1b / January 2019 ==

*/
	
if (!defined('CPO')) exit;

if (!function_exists('multitemplate_parser'))
{
	function multitemplate_parser ($template, $ersetzungs_array, $sql_res_array)
	{

	   GLOBAL $bereich_ende;
	   $inhalt_neu = array();
	   $start_flag  = 0;
	   $marke_start = 0; 
	   $marke_ende  = 0;
	   $bereich_start = 0;
	   $plh_zeilen  = "";
	   $inhalt_tpl  = explode("\n",$template);
	   while (list ($zeilennummer, $zeile) = each ($inhalt_tpl)) {
		 if ($zeilennummer > $bereich_ende) {
           if (stripos ($zeile, '<!-- START_MOD_MENU_NAVIGATION -->') !== false)
			 $bereich_start = $zeilennummer;
           elseif (stripos ($zeile, '<!-- ENDE_MOD_MENU_NAVIGATION -->') !== false) {
			 $bereich_ende = $zeilennummer+1;
			 break;
		   }
		 }
	   }

	   $inhalt_tpl  = explode("\n",$template);
	   while (list ($zeilennummer, $zeile) = each ($inhalt_tpl)) {
		 if (($zeilennummer > $bereich_start) and ($zeilennummer <= $bereich_ende)) {

		   if ($start_flag == 0) {
	         if (stripos ($zeile, '<!-- START_NAVITEM -->') !== false) {
				$start_flag = 1;
				$marke_start = $zeilennummer;
			 }
           } elseif (stripos ($zeile, '<!-- ENDE_NAVITEM -->') !== false) {
				$start_flag = 0;
				$marke_ende = $zeilennummer;
		   } else
				$plh_zeilen .= $zeile;
		 }
	   }
	  
	  $tmp_plh_zeilen = "";

	   //$anzahl_sql_ergebnis = count($sql_res_array);
	  for ($i = 0; $i < count($sql_res_array); $i++) {
		$tmp = $plh_zeilen;

		for ($j = 0; $j < count($ersetzungs_array); $j++) {
		  $ers_tag = $ersetzungs_array[$j][0];
		  $index   = $ersetzungs_array[$j][1];

		  $sql_res_array[$i][$index] = stripslashes ($sql_res_array[$i][$index]);
		  $tmp = str_replace($ers_tag, $sql_res_array[$i][$index], $tmp);
		  $tmp = stripslashes($tmp);
		}
		$tmp_plh_zeilen .= $tmp;
	  }
	   $plh_zeilen = $tmp_plh_zeilen;
	   
	  // Wiederherstellen des Datei-Inhalts
	  for ($i = $bereich_start; $i < $bereich_ende; $i++) {

		// vor der Start-Markierung
		if ($i < $marke_start) {
		   $inhalt_neu[$i] = $inhalt_tpl[$i];
		} elseif (($i >= $marke_start) and ($i < $marke_ende)) {
		// zwischen den Markierungen
		   $inhalt_neu[$i] =  $plh_zeilen;
		   $i = $marke_ende;  // Variable auf Zeile von marke_ende
		} else {
		// nach dem Markierungsende
		   $j = $marke_start + ($i - $marke_ende);
		   $inhalt_neu[$j] = $inhalt_tpl[$i];
		}
	  }
	  return ($inhalt_neu);
	}
}


if (!function_exists('getParent'))
{
	function getParent($navArray, $actRubric) {
		// erstmal die Rubrik selbst suchen
		$rubrik_left = 0;
		$rubrik_right = 0;
		$rubrik_level = 0;
		for ($ip;$ip<count($navArray);$ip++)  {
			if ($actRubric == $navArray[$ip]['rubric']['id'] OR $actRubric == $navArray[$ip]['rubric']['name'])  {
				$rubrik_left	= $navArray[$ip]['l'];
				$rubrik_right	= $navArray[$ip]['r'];
				$rubrik_level	= $navArray[$ip]['level'];
			}
		}
		// bergeordneten Eintrag suchen
		foreach ($navArray as $key=>$value) {
			if (($value['level'] == $rubrik_level-1) AND ($value['l'] < $rubrik_left) AND ($value['r'] > $rubrik_right))  {
				$parentID = $value['rubric']['id'];
			}
		}
		return $parentID;
	}
}

if (!function_exists('getTopNavCaption'))
{
	function getTopNavCaption($navArray, $actRubric) {
		// erstmal die Rubrik selbst suchen
		$rubrik_left = 0;
		$rubrik_right = 0;
		$rubrik_level = 0;
		for ($ip;$ip<count($navArray);$ip++)  {
			if ($actRubric == $navArray[$ip]['rubric']['id'] OR $actRubric == $navArray[$ip]['rubric']['name'])  {
				$rubrik_left	= $navArray[$ip]['l'];
				$rubrik_right	= $navArray[$ip]['r'];
				$rubrik_level	= $navArray[$ip]['level'];
			}
		}
		// bergeordneten Eintrag suchen
		foreach ($navArray as $key=>$value) {
			if (($value['level'] == 1) AND ($value['l'] < $rubrik_left) AND ($value['r'] > $rubrik_right))  {
				$parentNavCaption = $value['caption'];
			}
		}
		return $parentNavCaption;
	}
}

if (!function_exists('getID'))
{
	function getID($navArray, $actRubric) {
		// erstmal die Rubrik selbst suchen
		$rubrik_left = 0;
		$rubrik_level = 0;
		for ($ip;$ip<count($navArray);$ip++)  {
			if ($actRubric == $navArray[$ip]['rubric']['id'] OR $actRubric == $navArray[$ip]['rubric']['name'])  {
				$rubrik_ID	= $navArray[$ip]['rubric']['id'];
			}
		}
		return $rubrik_ID;
	}
}

if (!function_exists('getDirOnlyList'))
{
	function getDirOnlyList($base,$selectboxname,$selected)  {
		if(is_dir($base)){
			$dh = opendir($base);
			$m = 1;
			$count=0;
			echo "\n\n<!-- ---------------- Selectbox (Verzeichnis: ".$base." ) -------------- //-->\n";
			echo "<select id=\"template_select\" name=\"".$selectboxname."\" onChange=\"document.modulesettings.template_selected.value=document.modulesettings.template_select.value\">\n";
			while (false !== ($dir = readdir($dh))) {
				if (is_dir($base . $dir) && $dir !== '.' && $dir !== '..') {
					$subs = $dir    ;
					$subbase = $base . $dir . '/';
					$treewidth = namelength($subbase)*6;
					$select_string = '';
					if ($dir==$selected) $select_string = 'selected="selected"';
					echo '<option value="' . $dir . '"' . $select_string . '>' . $dir . '</option>';
					$count+=1;
					$m += 1;
				} else {
					next;
				}
			}
			listfiles($base,"&nbsp;");
			closedir($dh);
			echo "</select>\n";
		} else {
			print "Ist kein Verzeichnis!";
		}
		return $count;
	}
}

if (!function_exists('namelength'))
{
	function namelength($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			$length[]=strlen($file);
		}
		$max=max($length);
		return $max;
	}
}

if (!function_exists('listfiles'))
{
	function listfiles($dir,$m)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file))  {
				echo "<a href=\"".$PHP_SELF."?filedelete=".$dir.$file."\"><img src=\"del.gif\" border=\"0\" alt=\"Datei lschen\"></a>&nbsp;".$m."<img src=\"file.gif\"> <a href='".$dir.$file."' target=\"_blank\">".$file."</a><BR>";
			}
		}
		closedir($h);
	}
}

if (!function_exists('rubric_select'))
{
	function rubric_select($id,$selectbox_name,$act_selection,$disabled)  {
		$rubric_select = '<select class="select" style="min-width: 350px;" name="'.$selectbox_name.'"'.$disabled.'>';
		$rubric_select .= '<option value="">'.__('[none]').'</option>';

//		if (!empty($_SESSION['SID_user']['id'])) {

			// fetch all rubrics this user has access to
			if ($id) {
				$query = 'SELECT rubric_id '
					.'FROM '.CPO_RUBRIC_PERMISSION.' '
					."WHERE usergroups_id='".$id."' ";
			} else {
				$query = 'SELECT id AS rubric_id '
					.'FROM '.CPO_RUBRIC.' ';
			}
			DEBUG(1, $query, __FILE__, __LINE__);
			$db = new DB;
			$db->query($query);
			$rubricAccess = array();
			while ($db->next_record()) {
				$rubricAccess[$db->v('rubric_id')] = true;
			}

			// fetch all rubrics to show the ones not in navigation
			$query = 'SELECT id, name, seclevel '
					.'FROM '.CPO_RUBRIC.' '
					.'ORDER BY name';
			DEBUG(1, $query, __FILE__, __LINE__);
			$db->query($query);
			$notInNavigation = array();
			while ($db->next_record()) {
				$notInNavigation[$db->v('id')] = array(
					'id'=>0,
					'l'=>0,
					'r'=>0,
					'level'=>1,
					'childs'=>0,
					'caption'=>'',
					'navigation'=>array(),
					'rubric'=>array('id'=>$db->v('id'), 'name'=>$db->v('name'), 'seclevel'=>$db->v('seclevel'), )
				);
			}

			$navigation = getNavigation();
			foreach ($navigation as $k=>$v) {

				$path[$v['level']] = $v['caption'];

				if (array_key_exists($v['rubric']['id'], $notInNavigation)) unset($notInNavigation[$v['rubric']['id']]);

				if ($v['rubric']['id']<=0) continue;
				if (!array_key_exists($v['rubric']['id'], $rubricAccess)) continue;

				$entry = implode('/', array_slice($path, 0, $v['level']));
				if ($v['caption']!=$v['rubric']['name']) $entry .= ' ('.$v['rubric']['name'].')';
				if (strlen($entry)>90) $entry = '...'.substr($entry, -87);
				if ($v['rubric']['seclevel'] == SECLEVEL_CLOSED) $entry .= ' ['.__('closed').']';
				if ($v['rubric']['seclevel'] == SECLEVEL_PERSONALIZED) $entry .= ' ['.__('personalized').']';

				$rubric_select .= sprintf('<option value="%d" %s>%s</option>',
					$v['rubric']['id'],
					($v['rubric']['id']==$act_selection) ? 'selected' : '',
					$entry
				);
			}
			$_t = '<option value=""> </option>';
			foreach ($notInNavigation as $k=>$v) {
				if (!array_key_exists($v['rubric']['id'], $rubricAccess)) continue;
				print($_t);
				$_t = '';

				$path[$v['level']] = $v['rubric']['name'];

				$entry = implode('/', array_slice($path, 0, $v['level']));
				// no navigational element i
				// if ($v['caption']!=$v['rubric']['name']) $entry .= ' ('.$v['rubric']['name'].')';
				if (strlen($entry)>90) $entry = '...'.substr($entry, -87);

				$rubric_select .= sprintf('<option value="%d" %s>%s</option>',
					$v['rubric']['id'],
					($v['rubric']['id']==$act_selection) ? 'selected' : '',
					$entry
				);

			}
//		}
		$rubric_select .= '</select>';

		return $rubric_select;
	}
}

if (!function_exists('menu_tree_location'))
{
	function menu_tree_location($rubric_id, $navArray, $fill, $class='')  {
		global $tail;
		if (!isset($rubric_id)) return;
		if ($class != '') $class_string = ' class="' . $class . '"';
		for ($i=0;$i<count($navArray);$i++)  {
			if (!isset($navArray[$i]['rubric']['id'])) continue;
			if ($rubric_id == $navArray[$i]['rubric']['id'])  {
				$tail = $fill . '<a href="../' . $navArray[$i]['rubric']['directory'] . '/index.php?rubric=' . urlencode($navArray[$i]['rubric']['name']) . '"' . $class_string . '>' . htmlspecialchars($navArray[$i]['caption'], ENT_COMPAT, 'ISO-8859-15') . '</a>' . $tail;
				menu_tree_location(getParent($navArray, $navArray[$i]['rubric']['id']), $navArray, $fill, $class);
			}
		}
		return $tail;
	}
}

if (!function_exists('menu_tree_active'))
{
	function menu_tree_active($rubric_id, $navArray)  {
		global $active_items;
		if (!isset($rubric_id)) return;
		for ($i=0;$i<count($navArray);$i++)  {
			if (!isset($navArray[$i]['rubric']['id'])) continue;
			if ($rubric_id == $navArray[$i]['rubric']['id'])  {
				$active_items[] = $navArray[$i]['rubric']['id'];
				menu_tree_active(getParent($navArray, $navArray[$i]['rubric']['id']), $navArray);
			}
		}
		return $active_items;
	}
}

if (!function_exists('menu_tree_activeByID'))
{
	function menu_tree_activeByID($nav_id, $navArray)  {
		global $active_items;
		if (!isset($nav_id)) return;
		for ($i=0;$i<count($navArray);$i++)  {
			if (!isset($navArray[$i]['id'])) continue;
			if ($nav_id == $navArray[$i]['id'])  {
				$active_items[] = $navArray[$i]['rubric']['id'];
				menu_tree_activeByID(getParent($navArray, $navArray[$i]['id']), $navArray);
			}
		}
		return $active_items;
	}
}

if (!function_exists('menu_tree_active2'))
{
	function menu_tree_active2($rubric_id, $navArray, $active_items = array())  {
	//	global $active_items;
		if ($navArray=='') $navArray = getNavigation();
		if (!isset($rubric_id)) return;
		for ($i=0;$i<count($navArray);$i++)  {
			if (!isset($navArray[$i]['rubric']['id'])) continue;
			if ($rubric_id == $navArray[$i]['rubric']['id'])  {
				$active_items[] = $navArray[$i]['rubric']['id'];
				menu_tree_active(getParent($navArray, $navArray[$i]['rubric']['id']), $navArray, $active_items);
			}
		}
		return $active_items;
	}
}

if (!function_exists('getActiveNav'))
{
	function getActiveNav($navi='', $activeRubric=0)  // taken from the original Balu-Function
	{
		if ($navi=='') $navi = getNavigation();
		if (empty($navi)) return false;
		$naviElements = array();
		$actElements  = array();
		$currLevels   = array();

		foreach ($navi as $k=>$v) {
			$currLevels[$v['level']] = $v['id'];
			$naviElements[$v['id']] = $v; 
			if ($v['rubric']['id']==$activeRubric) {
				$actElements = array_splice($currLevels, 0, $v['level']);
			}
		}
		// add an element at position 0, 
		// so that $actElements[Y] makes Y equal the level
		array_unshift($actElements, 'X'); 
		return $actElements;
	}
}

if (!function_exists('getActiveNavByID'))
{
	function getActiveNavByID($navi='', $activeNavID=1)  // taken from the original Balu-Function
	{
		if ($navi=='') $navi = getNavigation();
		if (empty($navi)) return false;
		$naviElements = array();
		$actElements  = array();
		$currLevels   = array();

		foreach ($navi as $k=>$v) {
			$currLevels[$v['level']] = $v['id'];
			$naviElements[$v['id']] = $v; 
			if ($v['id']==$activeNavID) {
				$actElements = array_splice($currLevels, 0, $v['level']);
			}
		}
		// add an element at position 0, 
		// so that $actElements[Y] makes Y equal the level
		array_unshift($actElements, 'X'); 
		return $actElements;
	}
}

if (!function_exists('defineActiveNavigation'))
{
	function defineActiveNavigation($navi = '', $activeRubric = 0, $levels = 99, $parent = 0, $activeOnly = true)    // taken from the original Balu-Function
	{
		global $actNavArray;
		if ($navi=='') $navi = getNavigation();
		if (empty($navi)) return false;


		$actLevels = getActiveNav($navi, $activeRubric);

		$level = 0;
		if ($parent==0) $level = 1; // start with first level

		foreach ($navi as $k=>$v) {
			if ($v['level']<$level) $level = 0;            // printed all childs of active parent => clear $level
			if ($v['id']==$parent) $level = $v['level']+1; // found active parent => save $level
			if ($v['level']!=$level) continue;             // not the active level => continue

			$actNavArray[$v['id']] = 1;

			// RECURSION!
			if (
				(!$activeOnly || $actLevels[$level]==$v['id']) && // print only active sublevels
				$levels-1>0 // maximum number of levels to print
			) 
			defineActiveNavigation($navi, $activeRubric, $levels-1, $v['id'], $activeOnly);
		}
		return $actNavArray;
	}
}

if (!function_exists('defineActiveNavigationById'))
{
	function defineActiveNavigationById($navi = '', $activeNavID = 1, $levels = 99, $parent = 0, $activeOnly = true)    // taken from the original Balu-Function
	{
		global $actNavArray;
		if ($navi=='') $navi = getNavigation();
		if (empty($navi)) return false;


		$actLevels = getActiveNavByID($navi, $activeNavID);

		$level = 0;
		if ($parent==0) $level = 1; // start with first level

		foreach ($navi as $k=>$v) {
			if ($v['level']<$level) $level = 0;            // printed all childs of active parent => clear $level
			if ($v['id']==$parent) $level = $v['level']+1; // found active parent => save $level
			if ($v['level']!=$level) continue;             // not the active level => continue

			$actNavArray[$v['id']] = 1;

			// RECURSION!
			if (
				(!$activeOnly || $actLevels[$level]==$v['id']) && // print only active sublevels
				$levels-1>0 // maximum number of levels to print
			) 
			defineActiveNavigationById($navi, $activeNavID, $levels-1, $v['id'], $activeOnly);
		}
		return $actNavArray;
	}
}

?>