<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Menu"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version 4.1b / January 2019 ==

*/

define('CPO', true);

global $menu_license, $indentString;

// the includes ***********************************************************************************
require(CPO_BASEDIR.$activeModules['Menu']['directory'].'/includes/inc_build_nav.inc.php');

// anchor-prefix
$apre = $activeModules['Menu']['apre'];

// Bauen wir eine Sitemap
$ul_string .= "<!-- Start Sitemap -->\n<ul>\n";

for ($i=0;$i<count($nav_rubrik);$i++)  {
	if ($mod_menu_registered === FALSE && $i > 15)  break;

	$destination = 'int';
	if ($activeModules['Menu']['rubric_link'] == 'number') $nav_link = "../".$nav_rubrik_directory[$i]."/index.php?rubric=".$nav_rubrik_id[$i];
	if ($activeModules['Menu']['rubric_link'] == 'name')   $nav_link = "../".$nav_rubrik_directory[$i]."/index.php?rubric=".urlencode($nav_rubrik[$i]);
	if ($activeModules['Menu']['rubric_link'] == 'custom') $nav_link = str_replace( array('### NAV_DIR ###','### NAV_RUBRIC ###','### NAV_RUBRIC_ID ###'),  array($nav_rubrik_directory[$i],urlencode($nav_rubrik[$i]),$nav_rubrik_id[$i]), $activeModules['Menu']['custom']);
	$target = '';
	if ($nav_external_url[$i] != '' && $activeModules['Menu']['sitemap_external'] == '0')  {
		continue;
	}
	if ($nav_external_url[$i] != '')  {
		$nav_link = $nav_external_url[$i];
		$destination = 'ext';
	}

	// Zwischenstufen bei Levelwechsel
	if ($lastlevel != $level[$i] AND $lastlevel AND $lastlevel < $level[$i])  {				// Levelwechsel aufwrts
		$levchange_pre = "\n<ul>\n";
	} elseif ($lastlevel != $level[$i] AND $lastlevel AND $lastlevel > $level[$i])  {		// Levelwechsel abwrts
		$diff = $lastlevel - $level[$i];
		$levchange_pre = "</li>\n";
		for ($n=1;$n<=$diff;$n++)  {
			$levchange_pre .= "</ul>\n</li>\n";
		}
	} else {											// kein Levelwechsel
		if ($i!=0) $levchange_pre = "</li>\n";
	}

	$ul_string .=  $levchange_pre.'	<li>';
	$replace[] = "### SITEMAP_RUBRIC_LINK ###";
	$with[] = $nav_link;
	$replace[] = "### SITEMAP_RUBRIC_TITLE ###";
	$with[] = $nav_text[$i];
	$replace[] = "### SITEMAP_EXTERNAL_TARGET ###";
	$with[] = $nav_target[$i];
	$replace[] = "### SITEMAP_DESTINATION ###";
	$with[] = $destination;
	$query = "SELECT nr FROM ".CPO_NEWS." WHERE (rubric_id='".$nav_rubrik_id[$i]."' AND artikel_archiv=0)";
	DEBUG(2, $query, __FILE__, __LINE__);   
	$db = new DB;
	$db->query($query);
	$replace[] = "### SITEMAP_ARTICLE_COUNT ###";
	$with[] =  $db->num_rows();
	$ul_string .= str_replace($replace, $with, $activeModules['Menu']['sitemap_rubric']);
	unset ($replace, $with);

	if ($activeModules['Menu']['sitemap_details'] != 'no' && $nav_rubrik_id[$i])  {
		$query = "SELECT settings FROM ".CPO_RUBRIC." WHERE id='".$nav_rubrik_id[$i]."'";
		DEBUG(2, $query, __FILE__, __LINE__);   
		$db = new DB;
		$db->query($query);
		$db->next_record();
		$settings = unserialize($db->v("settings"));
		$art_number = ($settings['noOfArticles']) ? $settings['noOfArticles'] : $cpoRubricSettingsDefaults['noOfArticles'];
		$query = "SELECT titel, nr, verfallsdatum FROM ".CPO_NEWS
				." WHERE (rubric_id='".$nav_rubrik_id[$i]."'"
				." AND " . ($cpoSystem['release'] ? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED : 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED)
				." AND pub_datum<='".date('Y-m-d H:i:s')."') ORDER BY ".($settings['sorting'] ? $settings['sorting'] : $cpoRubricSettingsDefaults['sorting']);
		DEBUG(2, $query, __FILE__, __LINE__);   
		$db = new DB;
		$db->query($query);
		if ( ($activeModules['Menu']['sitemap_details'] == 'yes' && $db->num_rows()>0) || ($activeModules['Menu']['sitemap_details'] == 'more' && $db->num_rows()>1) )	{ 
			$num = 0;
			$start = '';
			while($db->next_record()):
				$num++;
				if ($num > $art_number) $start = "&pos=".floor($num/$art_number)*$art_number;
				if ($activeModules['Menu']['sitemapArticleLink'] == 'index')  {
					if ($activeModules['Menu']['rubric_link'] == 'number')	$nav_link = "../" . $nav_rubrik_directory[$i] . "/index.php?rubric=" . $nav_rubrik_id[$i] . $start . "#" . $apre . $db->v("nr");
					if ($activeModules['Menu']['rubric_link'] == 'name')	$nav_link = "../" . $nav_rubrik_directory[$i] . "/index.php?rubric=" . urlencode($nav_rubrik[$i]) . $start . "#" . $apre . $db->v("nr");
				}
				if ($activeModules['Menu']['sitemapArticleLink'] == 'detail')  {
					if ($activeModules['Menu']['rubric_link'] == 'number')	$nav_link = "../" . $nav_rubrik_directory[$i] . "/detail.php?rubric=" . $nav_rubrik_id[$i] . "&amp;nr=" . $db->v("nr");
					if ($activeModules['Menu']['rubric_link'] == 'name')	$nav_link = "../" . $nav_rubrik_directory[$i] . "/detail.php?rubric=" . urlencode($nav_rubrik[$i]) . "&amp;nr=" . $db->v("nr");
				}
				$ul_string .= '<br />';
				$replace[] = "### SITEMAP_ARTICLE_LINK ###";
				$with[] = $nav_link;
				$replace[] = "### SITEMAP_ARTICLE_TITLE ###";
				$with[] =  $db->v("titel");
				$ul_string .= str_replace($replace, $with, $activeModules['Menu']['sitemap_article']);
				unset ($replace, $with);

			endwhile;
		}
	}
	$lastlevel = $level[$i];
}
for ($u=0;$u<$lastlevel;$u++) $ul_string .=  "\n</li></ul>";

$ul_string .= "\n<!-- End Sitemap -->\n";

$ul_string = $menu_license.$ul_string.$menu_license;	// hier packen wir alles in eine Variable!
$ul_string = preg_replace("/(\015\012)|(\015)|(\012)/", '<<NEWLINE>>', $ul_string);
$ul_string = $indentString.implode("\n".$indentString,explode("<<NEWLINE>>",$ul_string));

if (!$mute) echo $ul_string;
?>
